
From: "Andi Kleen" <ak@suse.de>

This works around an AMD Erratum.

Signed-off-by: Andi Kleen <ak@suse.de>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 arch/x86_64/kernel/ptrace.c |    5 +++++
 1 files changed, 5 insertions(+)

diff -puN arch/x86_64/kernel/ptrace.c~x86_64-check-if-ptrace-rip-is-canonical arch/x86_64/kernel/ptrace.c
--- 25/arch/x86_64/kernel/ptrace.c~x86_64-check-if-ptrace-rip-is-canonical	2005-05-13 22:54:54.000000000 -0700
+++ 25-akpm/arch/x86_64/kernel/ptrace.c	2005-05-13 22:54:54.000000000 -0700
@@ -277,6 +277,11 @@ static int putreg(struct task_struct *ch
 				return -EIO;
 			value &= 0xffff;
 			break;
+		case offsetof(struct user_regs_struct, rip):
+			/* Check if the new RIP address is canonical */
+			if (value >= TASK_SIZE)
+				return -EIO;
+			break;
 	}
 	put_stack_long(child, regno - sizeof(struct pt_regs), value);
 	return 0;
_
